{{ header }} {{ column_left }}
<div id="content">
    <div class="page-header">
        <div class="container-fluid">
            <div class="pull-right">
                <button type="submit" form="form-module" data-toggle="tooltip" title="{{ button_save }}" class="btn btn-primary"><i class="fa fa-save"></i></button>
                <a href="{{ cancel }}" data-toggle="tooltip" title="{{ button_cancel }}" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
            <h1>{{ heading_title }}</h1>
            <ul class="breadcrumb">
                {% for breadcrumb in breadcrumbs %}
                    <li><a href="{{ breadcrumb.href }}">{{ breadcrumb.text }}</a></li>
                {% endfor %}
            </ul>
        </div>
    </div>
    <div class="container-fluid">
        {% if error_warning_keycrm %}
            <div class="alert alert-danger">
                <button type="button" class="close" data-dismiss="alert">&times;</button>
                <i class="fa fa-exclamation-circle"></i> {{ error_warning_keycrm }}
            </div>
        {% endif %}
        <div class="panel panel-default">
            <div class="panel-body">
                <form action="{{ action }}" method="post" enctype="multipart/form-data" id="form-module" class="form-horizontal">
                    <ul class="nav nav-tabs">
                        <li class="active"><a href="#tab-general" data-toggle="tab">{{ general_tab_text }}</a></li>
                        {% if saved_settings.api_key %}
                            <li><a href="#tab-order-statuses" data-toggle="tab">{{ order_statuses_tab_text }}</a></li>
                            <li><a href="#tab-payments" data-toggle="tab">{{ payments_tab_text }}</a></li>
                            <li><a href="#tab-shipping" data-toggle="tab">{{ shipping_tab_text }}</a></li>
                            <li><a href="#tab-export" data-toggle="tab">{{ export_tab_text }}</a></li>
                            <li><a href="#tab-logs" data-toggle="tab">{{ logs_tab_text }}</a></li>
                        {% endif %}
                    </ul>
                    <div class="tab-content">
                        <div class="tab-pane active" id="tab-general">
                            <fieldset>
                                <div class="form-group">
                                    <label class="col-sm-2 control-label" for="input-status">{{ entry_status }}</label>
                                    <div class="col-lg-4 col-md-6 col-sm-10 input-group">
                                        <select name="{{ module_title }}_status" id="input-status" class="form-control">
                                            {% if saved_settings.status %}
                                                <option value="1" selected="selected">{{ text_enabled }}</option>
                                                <option value="0">{{ text_disabled }}</option>
                                            {% else %}
                                                <option value="1">{{ text_enabled }}</option>
                                                <option value="0" selected="selected">{{ text_disabled }}</option>
                                            {% endif %}
                                        </select>
                                    </div>
                                </div>

                                <div class="form-group">
                                    <label class="col-sm-2 control-label" for="keycrm_url">{{ keycrm_url }}</label>
                                    <div class="col-lg-4 col-md-6 col-sm-10 input-group">
                                        <input
                                                class="form-control"
                                                id="keycrm_url"
                                                type="text"
                                                name="{{ module_title }}_url"
                                                value="{{ saved_settings.url }}">
                                        <span class="input-group-addon">.keycrm.app</span>
                                    </div>
                                </div>

                                <div class="form-group">
                                    <label class="col-sm-2 control-label" for="keycrm_api_key">{{ keycrm_api_key }}</label>
                                    <div class="col-lg-4 col-md-6 col-sm-10 input-group">
                                        <textarea class="form-control" id="keycrm_api_key" name="{{ module_title }}_api_key">{{ saved_settings.api_key }}</textarea>
                                        <small>{{ set_apikey_and_save }}</small>
                                    </div>

                                </div>

                                {% if sources|length %}
                                <div class="form-group">
                                    <label class="col-sm-2 control-label">{{ keycrm_stores }}</label>

                                    <div class="col-lg-6 col-md-8 col-sm-10">
                                        <table class="table">
                                            <thead>
                                                <tr>
                                                    <th>{{ stores_table_store }}</th>
                                                    <th>{{ stores_table_source }}</th>
                                                    <th>{{ stores_table_enabled }}</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                {% for idx, store in stores %}
                                                <tr>
                                                    <td>
                                                        {{ store.name }}
                                                        <input
                                                                type="hidden"
                                                                name="{{ module_title }}_stores[{{ idx }}][store_id]"
                                                                value="{{ store.store_id }}">
                                                    </td>
                                                    <td>
                                                        <select name="{{ module_title }}_stores[{{ idx }}][source_id]">
                                                            {% for source in sources %}
                                                                <option
                                                                        {% if saved_settings.stores[idx].source_id == source.id %}selected{% endif %}
                                                                        value="{{ source.id }}">
                                                                    {{ source.label }}
                                                                </option>
                                                            {% endfor %}
                                                        </select>
                                                    </td>
                                                    <td>
                                                        <input type="checkbox" name="{{ module_title }}_stores[{{ idx }}][enabled]" {% if saved_settings.stores[idx].enabled %} checked {% elseif saved_settings.stores[idx] is not defined %} checked {% endif %}>
                                                    </td>
                                                </tr>
                                                {% endfor %}
                                            </tbody>
                                        </table>

                                        <small>{{ select_source_and_save }}</small>
                                    </div>
                                </div>

                                <div class="well text-center">
                                    <button type="button" id="open-status-settings" class="btn btn-success">
                                        <i class="fa fa-check-square-o"></i> {{ button_status_settings }}
                                    </button>
                                </div>

                                {% endif %}
                            </fieldset>
                        </div>
                        {% if saved_settings.api_key %}
                            <div class="tab-pane" id="tab-order-statuses">
                            <fieldset>
                                <legend>{{ text_heading_order_statuses_settings }}</legend>

                                <div class="order-status-settings-wrapper">
                                    {% for order_status in order_statuses %}
                                        <div class="form-group ios8-wrapper">
                                            <input type='checkbox' class='ios8-switch' id='order_status_{{ order_status.order_status_id }}' name="{{ module_title }}_order_statuses[{{ order_status.order_status_id }}]" {% if saved_settings.order_statuses[order_status.order_status_id] is not empty %}checked{% endif %} {% if saved_settings.order_statuses is empty %}checked{% endif %} value="{{ order_status.order_status_id }}"  />
                                            <label for='order_status_{{ order_status.order_status_id }}'>
                                                {{ order_status.name }}
                                            </label>
                                        </div>
                                    {% endfor %}
                                    <div class="form-group ios8-wrapper">
                                        <input type='checkbox' class='ios8-switch' id='order_status_abandoned_cart' name="{{ module_title }}_order_statuses[abandoned_cart]" {% if saved_settings.order_statuses['abandoned_cart'] is not empty %}checked{% endif %} {% if saved_settings.order_statuses is empty %}checked{% endif %} value="abandoned_cart"  />
                                        <label for='order_status_abandoned_cart'>
                                            {{ text_abandoned_cart }}
                                        </label>
                                    </div>
                                </div>
                            </fieldset>
                        </div>
                            <div class="tab-pane" id="tab-payments">
                                <fieldset>
                                    {% if oc_payment_methods|length %}
                                        <div class="form-group">
                                            <div class="col-lg-4 col-md-6 col-sm-10 col-sm-offset-2">
                                                <label>
                                                    <input type="checkbox"
                                                           name="{{ module_title }}_create_payments"
                                                           {% if saved_settings.create_payments %}checked{% endif %}/>

                                                    {{ create_payments_text }}
                                                </label>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="col-sm-2 control-label">{{ keycrm_payment_methods }}</label>

                                            <div class="col-lg-6 col-md-8 col-sm-10">
                                                <table class="table">
                                                    <thead>
                                                    <tr>
                                                        <th>{{ payment_methods_table_oc_method }}</th>
                                                        <th>{{ payment_methods_table_kc_method }}</th>
                                                    </tr>
                                                    </thead>
                                                    <tbody>
                                                    {% for code, name in oc_payment_methods %}
                                                        <tr>
                                                            <td>
                                                                {{ name }}
                                                            </td>
                                                            <td>
                                                                <select name="{{ module_title }}_payment_methods[{{ code }}]">
                                                                    <option selected></option>
                                                                    {% for method in payment_methods %}
                                                                        <option
                                                                                {% if saved_settings.payment_methods[code] == method.id %}selected{% endif %}
                                                                                value="{{ method.id }}">
                                                                            {{ method.name }}
                                                                        </option>
                                                                    {% endfor %}
                                                                </select>
                                                            </td>
                                                        </tr>
                                                    {% endfor %}
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    {% endif %}
                                </fieldset>
                            </div>
                            <div class="tab-pane" id="tab-shipping">
                                <fieldset>
                                    <div class="form-group">
                                        <div class="col-lg-4 col-md-6 col-sm-10 col-sm-offset-2">
                                            <label>
                                                <input type="checkbox"
                                                       name="{{ module_title }}_create_shippings"
                                                       {% if saved_settings.create_shippings %}checked{% endif %}/>

                                                {{ create_shippings_text }}
                                            </label>
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <label class="col-sm-2 control-label">{{ keycrm_shipping_methods }}</label>

                                        <div class="col-lg-6 col-md-8 col-sm-10">
                                            <table class="table">
                                                <thead>
                                                <tr>
                                                    <th>{{ shipping_methods_table_oc_method }}</th>
                                                    <th>{{ shipping_methods_table_kc_method }}</th>
                                                </tr>
                                                </thead>
                                                <tbody id="shipping_methods_wrapper"></tbody>
                                            </table>
                                        </div>
                                    </div>
                                </fieldset>
                            </div>
                            <div class="tab-pane" id="tab-export">
                                <fieldset>
                                    {{ text_export_help }}<br /><br />
                                    {{ text_export_help2 }}<br /><br />
                                    <button type="button" id="export" class="btn btn-success">
                                        {{ text_button_export }}
                                        <i class="fa fa-download"></i>
                                    </button>

                                    <div class="row">
                                        <div id="export-progress-wrap" class="col-lg-4 col-md-6 col-sm-10">
                                           {# NOOP #}
                                        </div>
                                    </div>

                                    <hr />

                                    {{ text_export_one }}<br /><br />

                                    <div class="input-group">
                                        <input type="text" class="form-control" id="export-one-order-id" placeholder="{{ text_placeholder_export_one }}">
                                        <span class="input-group-btn">
                                            <button class="btn btn-default" id="export-one" type="button">{{ text_button_export_one}} <i class="fa fa-download"></i></button>
                                        </span>
                                    </div><!-- /input-group -->

                                    <div class="row">
                                        <div id="export-one-progress-wrap" class="col-lg-4 col-md-6 col-sm-10">
                                            &nbsp
                                        </div>
                                    </div>
                                </fieldset>
                            </div>
                            <div class="tab-pane" id="tab-logs">
                                <fieldset>
                                    <legend>KeyCRM API error log</legend>
                                    <div class="text-right" style="margin-bottom: 15px;">
                                        <a id="clear-log" data-toggle="tooltip" title="{{ text_button_clear }}" class="btn btn-danger">
                                            <i class="fa fa-eraser"></i> <span class="hidden-xs"><?php echo $button_clear; ?></span>
                                        </a>
                                    </div>

                                    {% if logs.keycrm_log is defined %}
                                        <div class="row">
                                            <div class="col-sm-12">
                                                <textarea id="keycrm-log" wrap="off" rows="15" readonly class="form-control">{{ logs.keycrm_log }}</textarea>
                                            </div>
                                        </div>
                                    {% endif %}
                                </fieldset>
                            </div>
                        {% endif %}
                    </div>
                    <br /><br /><br />KeyCRM Module Version: KEYCRM_MODULE_VERSION_AUTOMATICALLY_REPLACED_WITH_CI
                </form>
            </div>
        </div>
    </div>
</div>
{{ footer }}

<script type="text/javascript">
    var token = '{{ user_token }}';

    let $progress = $('#export-progress-wrap')
    let updateProgress = function () {
        $.ajax({
            url: '{{ catalog }}' + 'admin/index.php?route=extension/module/keycrm/exportProgress&user_token=' + token,
            success: function(response) {
                $progress.html(response)
            }
        })
    }

    let $progress_one = $('#export-one-progress-wrap')
    let updateProgressOne = function () {
	    $.ajax({
		    url: 'index.php?route=extension/module/keycrm/exportProgress&user_token=' + token,
		    success: function(response) {
			    $progress_one.html(response)
		    }
	    })
    }

    $('#export').on('click', function() {
        let intervalHandler = setInterval(updateProgress, 5000)

        $.ajax({
            url: '{{ catalog }}' + 'admin/index.php?route=extension/module/keycrm/exportOrders&user_token=' + token,
            beforeSend: function() {
                $('#export').button('loading');
            },
            complete: function() {
                $('.alert-success').remove();
                $('#content > .container-fluid').prepend('<div class="alert alert-success"><i class="fa fa-exclamation-circle"></i> {{ text_success_export }}</div>');
                $('#export').button('reset');
                $('#export-progress').css({widht: '100%'})
                clearInterval(intervalHandler)
            },
            error: function(){
                alert('error');
                clearInterval(intervalHandler)
            }
        });
    });

    $('#export-one').on('click', function() {
	    $('#export-progress').remove();
	    let intervalHandler = setInterval(updateProgressOne, 5000)
	    let order_id = $('#export-one-order-id').val();

	    $.ajax({
		    url: 'index.php?route=extension/module/keycrm/exportOrders&order_id=' + order_id + '&user_token=' + token,
		    beforeSend: function() {
			    $('#export-one').button('loading');
		    },
		    complete: function() {
			    $('.alert-success').remove();
			    $('#content > .container-fluid').prepend('<div class="alert alert-success"><i class="fa fa-exclamation-circle"></i> {{ text_success_export }}</div>');
			    $('#export-one').button('reset');
			    $('#export-progress').css({widht: '100%'})
			    clearInterval(intervalHandler)
		    },
		    error: function(){
			    alert('error');
			    clearInterval(intervalHandler)
		    }
	    });
    });

    $('#clear-log').on('click', function () {
        var r = confirm("Are you sure that you want to clear the log?");
        if (! r) {
            return
        }

        $.ajax({
            url: '{{ catalog }}' + 'admin/index.php?route=extension/module/keycrm/clearKeyCrmLog&user_token=' + token,
            async: true,
            success: function() {
                $('#keycrm-log').text('')
            }
        })
    })

    // Settings Order Statuses
    if ($('#open-status-settings').length) {
        $('#open-status-settings').on('click', function () {
            $('a[href="#tab-order-statuses"]').trigger('click');
        })
    }

    // Get Shipping methods
    getMethod('{{ api_key }}');

    let shipping_methods = {{ shipping_methods|json_encode() }};
    let shipping_methods_saved = {{ saved_settings['shipping_methods']|json_encode() }};

    // Shipping Methods
    function getMethod(tokenApi) {
	    $.ajax({
		    url: '{{ catalog }}index.php?route=api/keycrm/shipping/methods&token=' + tokenApi + '&api_token=' + tokenApi,
		    dataType: 'json',
		    beforeSend: function() {
			    $('#button-shipping-address').button('loading');
		    },
		    complete: function() {
			    $('#button-shipping-address').button('reset');
		    },
		    success: function(json) {
			    if (json['error']) {
				    $('#content > .container-fluid').prepend('<div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> ' + json['error'] + ' <button type="button" class="close" data-dismiss="alert">&times;</button></div>');
			    } else {
				    // Shipping Methods
				    let html = '';
				    if (json['shipping_methods']) {
					    for (i in json['shipping_methods']) {
						    if (!json['shipping_methods'][i]['error']) {
							    for (j in json['shipping_methods'][i]['quote']) {
								    html += '<tr>';
                                        html += "<td>";
                                            html += '(' + json['shipping_methods'][i]['title'] + '): ' + json['shipping_methods'][i]['quote'][j]['title'] + ' - ' + json['shipping_methods'][i]['quote'][j]['text'];
                                        html += "</td>";
                                        html += "<td>";
                                            html += '<select name="{{ module_title }}_shipping_methods[' + json['shipping_methods'][i]['quote'][j]['code'] + ']">';
                                            html += '<option></option>';
                                            for (let shipping_i = 0; shipping_i < shipping_methods.length; shipping_i++) {
                                                if (shipping_methods_saved && shipping_methods_saved[json['shipping_methods'][i]['quote'][j]['code']] == shipping_methods[shipping_i]['id']) {
                                                    html += '<option selected value="' + shipping_methods[shipping_i]['id'] + '">' + shipping_methods[shipping_i]['name'] + '</option>';
                                                } else {
                                                    html += '<option value="' + shipping_methods[shipping_i]['id'] + '">' + shipping_methods[shipping_i]['name'] + '</option>';
                                                }
                                            }
                                            html += '</select>';
                                        html += "</td>";
								    html += '</tr>';
							    }
						    } else {
							    html += '<div class="alert alert-danger">' + json['shipping_method'][i]['error'] + '</div>';
						    }
					    }
				    }

				    if (html) {
					    $('#shipping_methods_wrapper').html(html);
				    } else {
					    $('#shipping_methods_wrapper').html('<div class="alert alert-danger">{{ shipping_methods_not_found }}</div>');
				    }
			    }
		    },
		    error: function(xhr, ajaxOptions, thrownError) {
			    console.log(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
		    }
	    })
    }
</script>
